glibmm: Gio::FileIOStream Class Reference

glibmm 2.33.12

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions
Gio::FileIOStream Class Reference
Stream Classes

FileIOStream provides input streams that take their content from a file. More...

`#include <giomm/fileiostream.h>`

Inheritance diagram for Gio::FileIOStream:
[legend]

List of all members.

## Public Member Functions
virtual | ~FileIOStream ()
GFileIOStream* | gobj ()
| Provides access to the underlying C GObject.
const GFileIOStream* | gobj () const
| Provides access to the underlying C GObject.
GFileIOStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< FileInfo > | query_info (const Glib::RefPtr< Cancellable >& cancellable, const std::string& attributes="*")
| Queries a file input stream the given attributes.
Glib::RefPtr< FileInfo > | query_info (const std::string& attributes="*")
| Queries a file input stream the given attributes.
void | query_info_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, const std::string& attributes="*", int io_priority=Glib::PRIORITY_DEFAULT)
| Queries the stream information asynchronously.
void | query_info_async (const SlotAsyncReady& slot, const std::string& attributes="*", int io_priority=Glib::PRIORITY_DEFAULT)
| Queries the stream information asynchronously.
Glib::RefPtr< FileInfo > | query_info_finish (const Glib::RefPtr< AsyncResult >& result)
| Finalizes the asynchronous query started by g_file_io_stream_query_info_async().
std::string | get_etag () const
| Gets the entity tag for the file when it has been written.
Public Member Functions inherited from Gio::IOStream
virtual | ~IOStream ()
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()
Public Member Functions inherited from Gio::Seekable
virtual | ~Seekable ()
goffset | tell () const
| Tells the current position within the stream.
bool | can_seek () const
| Tests if the stream supports the SeekableIface.
bool | seek (goffset offset, Glib::SeekType type, const Glib::RefPtr< Cancellable >& cancellable)
| Seeks in the stream by the given offset, modified by type.
bool | seek (goffset offset, Glib::SeekType type)
| Seeks in the stream by the given offset, modified by type .
bool | can_truncate () const
| Tests if the stream can be truncated.
bool | truncate (goffset offset, const Glib::RefPtr< Cancellable >& cancellable)
| Truncates a stream with a given #offset.
bool | truncate (goffset offset)
| Truncates a stream with a given #offset.
Public Member Functions inherited from Glib::Interface
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes.
| Interface (GObject* castitem)
| Called by constructors of derived classes.
virtual | ~Interface ()

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::Seekable
static void | add_interface (GType gtype_implementer)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::FileIOStream > | wrap (GFileIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::Seekable
Glib::RefPtr< Gio::Seekable > | wrap (GSeekable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Protected Member Functions inherited from Gio::Seekable
| Seekable ()
| You should derive from this class to use it.

## Detailed Description

FileIOStream provides input streams that take their content from a file.

FileInputStream implements Seekable, which allows the input stream to jump to arbitrary positions in the file, provided the file system of the file allows it. Use the methods of the Seekable base class for seeking and positioning.

Since glibmm 2.22:

## Constructor & Destructor Documentation

virtual Gio::FileIOStream::~FileIOStream | ( |  | ) |
| virtual

## Member Function Documentation

std::string Gio::FileIOStream::get_etag | ( |  | ) | const

Gets the entity tag for the file when it has been written.

This must be called after the stream has been written and closed, as the etag can change while writing.

Since glibmm 2.22:

Returns:
  The entity tag for the stream.

static GType Gio::FileIOStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

Reimplemented from Gio::IOStream.

GFileIOStream* Gio::FileIOStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::IOStream.

const GFileIOStream* Gio::FileIOStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::IOStream.

GFileIOStream* Gio::FileIOStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::IOStream.

Glib::RefPtr<FileInfo> Gio::FileIOStream::query_info | ( | const Glib::RefPtr< Cancellable >& | cancellable,
|  | const std::string & | attributes = `"*"`
| ) |  |

Queries a file input stream the given attributes.

This function blocks while querying the stream. For the asynchronous (non-blocking) version of this function, see query_info_async(). While the stream is blocked, the stream will set the pending flag internally, and any other operations on the stream will throw a Gio::Error with PENDING.

Parameters:

  attributes | A file attribute query string.
  cancellable | A Cancellable object.

Returns:
  A FileInfo, or an empty RefPtr on error.

Glib::RefPtr<FileInfo> Gio::FileIOStream::query_info | ( | const std::string & | attributes = `"*"` | ) |

Queries a file input stream the given attributes.

This function blocks while querying the stream. For the asynchronous (non-blocking) version of this function, see query_info_async(). While the stream is blocked, the stream will set the pending flag internally, and any other operations on the stream will throw a Gio::Error with PENDING.

Parameters:

  attributes | A file attribute query string.

Returns:
  A FileInfo, or an empty RefPtr on error.

void Gio::FileIOStream::query_info_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | const std::string & | attributes = `"*"`,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

Queries the stream information asynchronously.

For the synchronous version of this function, see query_info().

    The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error with CANCELLED will be thrown.

    When the operation is finished, @a slot will be called. You can then call query_info_finish() to get the result of the operation.

    @param slot A callback slot which will be called when the request is satisfied.
    @param cancellable A Cancellable object which can be used to cancel the operation.
    @param attributes A file attribute query string.
    @param io_priority The I/O priority of the request.

void Gio::FileIOStream::query_info_async | ( | const SlotAsyncReady& | slot,
|  | const std::string & | attributes = `"*"`,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

Queries the stream information asynchronously.

For the synchronous version of this function, see query_info().

    When the operation is finished, @a slot will be called. You can then call query_info_finish() to get the result of the operation.

    @param slot A callback slot which will be called when the request is satisfied.
    @param attributes A file attribute query string.
    @param io_priority The I/O priority of the request.

Glib::RefPtr<FileInfo> Gio::FileIOStream::query_info_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Finalizes the asynchronous query started by g_file_io_stream_query_info_async().

Since glibmm 2.22:

Parameters:

  result | A AsyncResult.

Returns:
  A FileInfo for the finished query.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::FileIOStream > wrap | ( | GFileIOStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.